{
  POP3 Mail Checker

  About dialog

  Roman M. Mochalov
  E-mail: roman@sar.nnov.ru
}

unit MC_About;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TAboutForm = class(TForm)
    LogoImage: TImage;
    ProductLabel: TLabel;
    VersionLabel: TLabel;
    CopyrightLabel: TLabel;
    CommentsLabel: TLabel;
    Divider: TBevel;
    OKButton: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function ShowAboutDialog: Boolean;

implementation

{$R *.DFM}

function GetVersionStr(const FileName, Key, Default: string): string;
const
  SLang = '\\VarFileInfo\\Translation';
  SBlock = '\\StringFileInfo\\%.4x%.4x\\%s';
type
  PLangList = ^TLangList;
  TLangList = array[0..MAXINT div SizeOf(LongRec) - 1] of LongRec;
var
  Handle: DWORD;
  Size: DWORD;
  Data: Pointer;
  Buffer: Pointer;
  Len: UINT;
  LangCount, I: Integer;
  Lang, CharSet: Word;
  Block: string;
begin
  Result := Default;
  Size := GetFileVersionInfoSize(PChar(FileName), Handle);
  if Size > 0 then
  begin
    GetMem(Data, Size);
    if Data <> nil then
    try
      if not GetFileVersionInfo(PChar(FileName), Handle, Size, Data) then Exit;
      if not VerQueryValue(Data, '\\', Buffer, Len) then Exit;
      if not VerQueryValue(Data, SLang, Buffer, Len) then Exit;
      LangCount := Len div SizeOf(LongRec);
      for I := 0 to LangCount - 1 do
      begin
        Lang := LongRec(PLangList(Buffer)^[I]).Lo;
        CharSet := LongRec(PLangList(Buffer)^[I]).Hi;
        Block := Format(SBlock, [Lang, CharSet, Key]);
        if VerQueryValue(Data, PChar(Block), Buffer, Len) then
        begin
          Len := StrLen(PChar(Buffer));
          if Len > 0 then
          begin
            SetString(Result, PChar(Buffer), Len);
            Exit;
          end;
        end;
      end;
    finally
      FreeMem(Data, Size);
    end;
  end;
end;

function ShowAboutDialog: Boolean;
var
  I: Integer;
  F: TForm;
begin
  { Fing previous dialog }
  for I := 0 to Screen.FormCount - 1 do
  begin
    F := Screen.Forms[I];
    if F.ClassName = TAboutForm.ClassName then
    begin
      F.BringToFront;
      Result := True;
      Exit;
    end;
  end;
  { Create dialog form }
  with TAboutForm.Create(Application) do
  try
    { Get version info }
    Caption := Format(Caption, [Application.Title]);
    LogoImage.Picture.Graphic := Application.Icon;
    ProductLabel.Caption := GetVersionStr(ParamStr(0), 'FileDescription', '');
    VersionLabel.Caption := Format(VersionLabel.Caption, [GetVersionStr(ParamStr(0), 'FileVersion', '')]);
    CopyrightLabel.Caption := GetVersionStr(ParamStr(0), 'LegalCopyright', '');
    CommentsLabel.Caption := GetVersionStr(ParamStr(0), 'Comments', '');
    { Show dialog }
    Result := ShowModal = mrOK;
  finally
    Free;
  end;
end;

end.
