{
  POP3 Mail Checker

  Main Checker form

  Roman M. Mochalov
  E-mail: roman@sar.nnov.ru
}

unit MC_Form;

interface

uses
  Windows, Messages, ShellAPI, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, CommCtrl, ComCtrls, Menus, Registry, MMSystem, Printers,
  MC_Mail, MC_Options, MC_Tray;

type
  TCheckerForm = class(TForm)
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileDeleteItem: TMenuItem;
    FileN1Item: TMenuItem;
    FilePrintItem: TMenuItem;
    FileN2Item: TMenuItem;
    FilePropertiesItem: TMenuItem;
    FileN3Item: TMenuItem;
    FileExitItem: TMenuItem;
    ViewMenu: TMenuItem;
    ViewStatusBarItem: TMenuItem;
    ViewN1Item: TMenuItem;
    ViewSortMenu: TMenuItem;
    ViewSortFromItem: TMenuItem;
    ViewSortSubjectItem: TMenuItem;
    ViewSortDateItem: TMenuItem;
    ViewSortN1Item: TMenuItem;
    ViewSortDirectItem: TMenuItem;
    ViewN2Item: TMenuItem;
    ViewCharSetMenu: TMenuItem;
    ViewDOSItem: TMenuItem;
    ViewWINItem: TMenuItem;
    ViewKOIItem: TMenuItem;
    ViewN3Item: TMenuItem;
    ViewN11Item: TMenuItem;
    ViewNoItem: TMenuItem;
    ViewRefreshItem: TMenuItem;
    MailMenu: TMenuItem;
    MailCheckItem: TMenuItem;
    MailN1Item: TMenuItem;
    MailReaderItem: TMenuItem;
    MailN2Item: TMenuItem;
    MailOptionsItem: TMenuItem;
    HelpMenu: TMenuItem;
    HelpTopicsItem: TMenuItem;
    HelpN1Item: TMenuItem;
    HelpAboutItem: TMenuItem;
    PopupMenu: TPopupMenu;
    PopupN0Item: TMenuItem;
    PopupOpenItem: TMenuItem;
    PopupN1Item: TMenuItem;
    PopupPrintItem: TMenuItem;
    PopupSaveItem: TMenuItem;
    PopupDeleteItem: TMenuItem;
    PopupN2Item: TMenuItem;
    PopupPropertiesItem: TMenuItem;
    TrayMenu: TPopupMenu;
    TrayAboutItem: TMenuItem;
    TrayN1Item: TMenuItem;
    TrayCheckerItem: TMenuItem;
    TrayOptionsItem: TMenuItem;
    TrayN2Item: TMenuItem;
    TrayCheckItem: TMenuItem;
    TrayN3Item: TMenuItem;
    TrayExitItem: TMenuItem;
    SmallImages: TImageList;
    Timer: TTimer;
    MailView: TListView;
    StatusBar: TStatusBar;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    ViewSortSizeItem: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FileMenuClick(Sender: TObject);
    procedure FileOpenItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    procedure FileDeleteItemClick(Sender: TObject);
    procedure FilePrintItemClick(Sender: TObject);
    procedure FilePropertiesItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure ViewMenuClick(Sender: TObject);
    procedure ViewStatusBarItemClick(Sender: TObject);
    procedure ViewSortMenuClick(Sender: TObject);
    procedure ViewSortItemClick(Sender: TObject);
    procedure ViewSortDirectItemClick(Sender: TObject);
    procedure ViewCharSetMenuClick(Sender: TObject);
    procedure ViewCharSetItemClick(Sender: TObject);
    procedure ViewRefreshItemClick(Sender: TObject);
    procedure MailMenuClick(Sender: TObject);
    procedure MailCheckItemClick(Sender: TObject);
    procedure MailReaderItemClick(Sender: TObject);
    procedure MailOptionsItemClick(Sender: TObject);
    procedure HelpTopicsItemClick(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure TrayMenuPopup(Sender: TObject);
    procedure TrayCheckerItemClick(Sender: TObject);
    procedure TrayIconPopup(Sender: TObject; var AllowPopup: Boolean);
    procedure TimerTimer(Sender: TObject);
    procedure MailViewColumnClick(Sender: TObject; Column: TListColumn);
    procedure MailViewDblClick(Sender: TObject);
    procedure MailViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    FMailBox: TMailBox;
    FOptions: TOptions;
    FCharSet: Integer;
    FSortColumn: Integer;
    FSortDirect: Integer;
    FAppMessage: Cardinal;
    FAppMutex: THandle;
    FTrayIcon: TTrayIcon;
    FTrayHint: string;
    FPOPCount: Integer;
    FDialogMsg: Boolean;
    procedure AppException(Sender: TObject; E: Exception);
    function AppHook(var Message: TMessage): Boolean;
    procedure AppHint(Sender: TObject);
    procedure CheckPrevInstance;
    function GetMessageNum: Integer;
    procedure Hide;
    procedure LoadWindowPlacement;
    procedure SaveWindowPlacement;
    procedure SetCharSet(Value: Integer);
    procedure SetSortColumn(Value: Integer);
    procedure SetSortDirect(Value: Integer);
    procedure SetTrayHint(const Hint: string);
    procedure SetTrayHintIcon(const Hint: string; Icon: Integer);
    function StartDialog: Boolean;
    function StopDialog: Boolean;
    procedure UpdateTimer;
    procedure UpdateListView;
    procedure WMClose(var Message: TMessage); message WM_CLOSE;
    procedure WMDestroy(var Message: TMessage); message WM_DESTROY;
    procedure WMSysCommand(var Message: TWMSysCommand); message WM_SYSCOMMAND;
  public
    function CheckNewMail(ManualCheck: Boolean): Boolean;
    function DeleteMessage(MsgNums: array of Integer): Boolean;
    procedure LaunchReader(const Reader: string);
    function LoadMessage(MsgNum: Integer): Boolean;
    function OpenMessage(MsgNum: Integer): Boolean;
    function PrintMessage(MsgNum: Integer): Boolean;
    function SaveMessage(MsgNum: Integer): Boolean;
    property CharSet: Integer read FCharSet;
    property MailBox: TMailBox read FMailBox;
    property MessageNum: Integer read GetMessageNum;
    property Options: TOptions read FOptions;
    property SortColumn: Integer read FSortColumn;
    property SortDirect: Integer read FSortDirect;
  end;

var
  CheckerForm: TCheckerForm;

implementation

uses
  MC_POP3, MC_Source, MC_Properties, MC_About, MC_MsgBox, MC_CharSet,
  MC_Consts;

{$R *.DFM}
{$R *.RES}

function CustomSortProc(Item1, Item2: TListItem; ParamSort: integer): Integer; stdcall;
var
  Msg1, Msg2: TMailMessage;
begin
  Result := 0;
  try
    Msg1 := TMailMessage(Item1.Data);
    Msg2 := TMailMessage(Item2.Data);
    { Compare messages }
    case ParamSort of
      0: Result := AnsiCompareText(Msg1.From, Msg2.From);
      1: Result := AnsiCompareText(Msg1.Subject, Msg2.Subject);
      2: Result := AnsiCompareText(Msg1.Date, Msg2.Date);
      3: if Msg1.MsgSize > Msg2.MsgSize then Result := 1
         else if Msg1.MsgSize < Msg2.MsgSize then Result := -1;
    end;
    { Sort direction }
    Result := Result * TCheckerForm(Item1.Owner.Owner.Owner).FSortDirect;
  except
    { Ignore exceptions }
  end;
end;

{ TCheckerForm }

const
  SRegistryKey = 'Software\Mail Checker\1.0';
  SInstanceName = 'POP3 Mail Checker';

procedure TCheckerForm.AppException(Sender: TObject; E: Exception);
const
  Flags = MB_ICONERROR or MB_OK;
begin
  AppMessageBoxFmt(SUnexpectedError, Caption, Flags, [E.Message, E.ClassName]);
end;

function TCheckerForm.AppHook(var Message: TMessage): Boolean;
begin
  if (Message.Msg = WM_SYSCOMMAND) and ((Message.WParam and $FFF0) = SC_CLOSE) then
  begin
    { "Close" command }
    Hide;
    Result := True;
  end
  else if Message.Msg = FAppMessage then
  begin
    { "Activate instance" message }
    TrayCheckerItemClick(TrayCheckerItem);
    Result := True;
  end
  else
    Result := False;
end;

procedure TCheckerForm.AppHint(Sender: TObject);
begin
  if Length(Application.Hint) = 0 then
  begin
    StatusBar.SimplePanel := True;
    StatusBar.SimpleText := FTrayHint
  end
  else
  begin
    StatusBar.SimplePanel := False;
    StatusBar.Panels[0].Text := Application.Hint;
  end;
end;

function TCheckerForm.GetMessageNum: Integer;
begin
  with MailView do
  begin
    if SelCount <> 1 then
    begin
      Result := -1;
      Exit;
    end;
    Result := TMailMessage(Selected.Data).MsgNum;
  end;
end;

procedure TCheckerForm.CheckPrevInstance;
var
  AppMutex: THandle;
  Recipients: DWORD;
begin
  { Register windows message }
  FAppMessage := RegisterWindowMessage(PChar(SInstanceName));
  { Create app  mutex }
  AppMutex := CreateMutex(nil, False, PChar(SInstanceName));
  { Check instance exists }
  if GetLastError <> ERROR_ALREADY_EXISTS then
  begin
    FAppMutex := AppMutex;
    Exit;
  end;
  { Instance not exists, activate prev instance }
  CloseHandle(AppMutex);
  Recipients := BSM_APPLICATIONS;
  BroadcastSystemMessage(BSF_IGNORECURRENTTASK or BSF_POSTMESSAGE, @Recipients, FAppMessage, 0, 0);
  { Quit program }
  Halt;
end;

procedure TCheckerForm.Hide;
var
  I: Integer;
  Form: TCustomForm;
begin
  { Close sourcve windows }
  for I := Screen.FormCount - 1 downto 0 do
  begin
    Form := Screen.Forms[I];
    if Form is TSourceForm then Form.Close;
  end;
  { Hide main window }
  inherited Hide;
  inherited UpdateControlState;
end;

procedure TCheckerForm.LoadWindowPlacement;
var
  I: Integer;
  Ident: string;
begin
  with TRegIniFile.Create(SRegistryKey) do
  try
    { Load placment from registry }
    Left := ReadInteger('', 'Left', Left);
    Top := ReadInteger('', 'Top', Top);
    Width := ReadInteger('', 'Width', Width);
    Height := ReadInteger('', 'Height', Height);
    { Load window state }
    WindowState := TWindowState(ReadInteger('', 'State', Ord(WindowState)));
    { Load view params }
    FSortColumn := ReadInteger('', 'SortColumn', 0);
    FSortDirect := ReadInteger('', 'SortDirect', -1);
    FCharSet := ReadInteger('', 'CharSet', -1);
    StatusBar.Visible := ReadBool('', 'StatusBar', True);
    { Load columns params }
    with MailView do
    begin
      HandleNeeded;
      for I := 0 to Columns.Count - 1 do
      begin
        Ident := Format('Column%d', [I]);
        ListView_SetColumnWidth(Handle, I, ReadInteger('', Ident, Columns[I].Width));
      end;
    end;
  finally
    Free;
  end;
end;

procedure TCheckerForm.SaveWindowPlacement;
var
  Placement: TWindowPlacement;
  I: Integer;
  Ident: string;
begin
  with TRegIniFile.Create(SRegistryKey) do
  try
    { Get window placement }
    Placement.Length := SizeOf(TWindowPlacement);
    GetWindowPlacement(Handle, @Placement);
    { Write placment to registry }
    with Placement.rcNormalPosition do
    begin
      WriteInteger('', 'Left', Left);
      WriteInteger('', 'Top', Top);
      WriteInteger('', 'Width', Right - Left);
      WriteInteger('', 'Height', Bottom - Top);
    end;
    { Write window state }
    WriteInteger('', 'State', Ord(WindowState));
    { Write view params }
    WriteInteger('', 'SortColumn', FSortColumn);
    WriteInteger('', 'SortDirect', FSortDirect);
    WriteInteger('', 'CharSet', FCharSet);
    WriteBool('', 'StatusBar', StatusBar.Visible);
    { Write columns params }
    for I := 0 to MailView.Columns.Count - 1 do
    begin
      Ident := Format('Column%d', [I]);
      WriteInteger('', Ident, MailView.Columns[I].Width);
    end;
  finally
    Free;
  end;
end;

procedure TCheckerForm.SetCharSet(Value: Integer);
begin
  FCharSet := Value;
  UpdateListView;
end;

procedure TCheckerForm.SetSortColumn(Value: Integer);
begin
  FSortColumn := Value;
  MailView.CustomSort(@CustomSortProc, FSortColumn);
end;

procedure TCheckerForm.SetSortDirect(Value: Integer);
begin
  FSortDirect := Value;
  MailView.CustomSort(@CustomSortProc, FSortColumn);
end;

procedure TCheckerForm.SetTrayHint(const Hint: string);
begin
  { Format hint message }
  FTrayHint := Hint;
  if Length(FTrayHint) = 0 then FTrayHint := Format(SMessages, [FMailBox.Count]);
  { Set hint }
  FTrayIcon.Hint := FTrayHint;
  StatusBar.SimpleText := FTrayHint;
  StatusBar.Update;
end;

procedure TCheckerForm.SetTrayHintIcon(const Hint: string; Icon: Integer);
var
  IconName: string;
begin
  { Get icon index }
  if Icon = -2 then IconName := 'MBOX0E'
  else if Icon = -1 then IconName := 'MBOX0W'
  else if Icon > 9 then IconName := 'MBOX99'
  else IconName := Format('MBOX%d', [Icon]);
  { Set icon }
  FTrayIcon.Icon.Handle := LoadImage(HInstance, PChar(IconName), IMAGE_ICON, 0, 0, LR_VGACOLOR);
  { Set hint }
  SetTrayHint(Hint);
end;

function TCheckerForm.StartDialog: Boolean;
begin
  { Check already once shown }
  if FDialogMsg then
  begin
    Application.Restore;
    Application.BringToFront;
    Result := False;
    Exit;
  end;
  { Dialog allowed }
  FDialogMsg := True;
  Result := True;
end;

function TCheckerForm.StopDialog: Boolean;
begin
  FDialogMsg := False;
  Result := True;
end;

procedure TCheckerForm.UpdateTimer;
begin
  with FOptions do
  begin
    Timer.Interval := CheckInterval * 60 * 1000;
    Timer.Enabled := False;
    Timer.Enabled := Checking;
  end;
end;

procedure TCheckerForm.UpdateListView;
var
  I: Integer;
  R: TRect;
begin
  if not (csLoading in ComponentState) then
    with MailView do
    begin
      { Hide selected message }
      for I := 0 to Items.Count - 1 do Items[I].Selected := False;
      { Synchronize items count with message count }
      if Items.Count > FMailBox.Count then
      begin
        I := Items.Count;
        while I > FMailBox.Count do
        begin
          Dec(I);
          Items.Delete(I);
        end;
      end
      else if Items.Count < FMailBox.Count then
      begin
        I := Items.Count;
        while I < FMailBox.Count do
        begin
          Inc(I);
          with Items.Add do
          begin
            SubItems.Add(''); { [0 - Subject] }
            SubItems.Add(''); { [1 - Date] }
            SubItems.Add(''); { [2 - Size] }
          end;
        end;
      end;
      { Update items }
      for I := 0 to FMailBox.Count - 1 do
        with Items[I], FMailBox[I] do
        begin
          { Set item params }
          Caption := ChangeCharSet(From, FCharSet, CS_WIN);
          SubItems[0] := ChangeCharset(Subject, FCharSet, CS_WIN);
          SubItems[1] := ChangeCharset(Date, FCharSet, CS_WIN);
          SubItems[2] := Format(SMessageSize, [MsgSize * 1.0]);
          Data := FMailBox[I];
          { Invalidate item }
          R := DisplayRect(drBounds);
          InvalidateRect(Handle, @R, False);
        end;
      { Resort items }
      CustomSort(@CustomSortProc, FSortColumn);
    end;
end;

procedure TCheckerForm.WMClose(var Message: TMessage);
begin
  Hide;
end;

procedure TCheckerForm.WMDestroy(var Message: TMessage);
begin
  SaveWindowPlacement;
  inherited;
end;

procedure TCheckerForm.WMSysCommand(var Message: TWMSysCommand);
begin
  if (Message.CmdType and $FFF0 = SC_CLOSE) then
  begin
    Hide;
    Exit;
  end;
  inherited;
end;

function TCheckerForm.CheckNewMail(ManualCheck: Boolean): Boolean;
const
  Flags: Integer = MB_ICONWARNING or MB_OK;
var
  NewMail: Boolean;
  I, NewCount, Index1, Index2: Integer;
  TmpBox: TMailBox;
  MsgText: string;
  MsgSize: Integer; 
begin
  Result := False;
  { Check POP3 active }
  if FPOPCount = 0 then
  begin
    { Set POP3 counter  }
    Inc(FPOPCount);
    try
      NewMail := False;
      { Start POP3 session }
      with TPOP3Session.Create do
      try
        { Connect to the server }
        SetTrayHintIcon(SConnecting, -1);
        if not Connect(FOptions.Host, FOptions.Port, FOptions.TimeOut) then
        begin
          SetTrayHintIcon(SConnectError, -2);
          Exit;
        end;
        { Login }
        SetTrayHintIcon(SAuthorisation, -1);
        if not Login(FOptions.UserName, FOptions.Password) then
        begin
          SetTrayHintIcon(SAuthoriseError, -2);
          Exit;
        end;
        { Show "checking..." hint  }
        SetTrayHintIcon(SCheckingMail, -1);
        { List messages }
        if not ListMessages(NewCount) then
        begin
          { Show "Error" hint }
          SetTrayHintIcon(SCheckError, -2);
        end;
        { Create temporary mail box }
        TmpBox := TMailBox.Create;
        try
          I := 1;
          { Retreive headers }
          while I <= NewCount do
          begin
            if not (RetrieveHeader(I, MsgText) and ListMessageSize(I, MsgSize)) then
            begin
              { Show "Error" hint }
              SetTrayHintIcon(SCheckError, -2);
              Break;
            end;
            { Add mail to the list }
            Index1 := TmpBox.Add(I, MsgSize, MsgText);
            Index2 := FMailBox.IndexOfMessageID(TmpBox[Index1].MessageID);
            { Check new message }
            NewMail := NewMail or (Index2 = -1);
            { Check existing message body already downloaded }
            if (Index2 <> -1) and FMailBox[Index2].FullSource then
            begin
              TmpBox[Index1].Text := FMailBox[Index2].Text;
              TmpBox[Index1].FullSource := True;
            end;
            { Next message }
            Inc(I);
          end;
          { Check all items complete }
          if I > NewCount then
          begin
            FMailBox.Assign(TmpBox);
            UpdateListView;
            { Success }
            Result := True;
            SetTrayHintIcon('', FMailBox.Count);
          end;
        finally
          TmpBox.Free;
        end;
      finally
        Quit;
        Free;
      end;
      { Checking signalization }
      if not Application.Terminated then
      begin
        { Check for new mail signalisation }
        if NewMail then
        begin
          { Beep on new mail }
          if FOptions.MessageBeep then sndPlaySound('MailBeep', SND_ASYNC);
          { Launch external mail reader }
          if FOptions.ShowReader then LaunchReader(Options.MailReader);
        end;
        { Show message box }
        if FOptions.MessageBox or ManualCheck then
        begin
          MsgText := '';
          { Get message text }
          if not Result then MsgText := FTrayIcon.Hint + '.'
          else if NewMail then MsgText := SNewMail
          else if ManualCheck then MsgText := SNoNewMail;
          { Message box }
          if Length(MsgText) <> 0 then AppMessageBox(MsgText, Caption, Flags);
        end;
      end;
    finally
      Dec(FPOPCount);
    end;
  end;
end;

function TCheckerForm.DeleteMessage(MsgNums: array of Integer): Boolean;
var
  I, Index: Integer;
  Text: string;

  function DeleteQuery: Boolean;
  const
    Texts: array[Boolean] of string = (SDeleteQuery, SDeleteQueryAll);
    Flags = MB_ICONQUESTION or MB_YESNO or MB_DEFBUTTON2;
  var
    Query: string;
  begin
    Query := Texts[High(MsgNums) - Low(MsgNums) > 0];
    Result := AppMessageBox(Query, Caption, Flags) = ID_YES;
  end;

begin
  Result := False;
  { Check POP3 active, show delete query }
  if (FPOPCount = 0) and DeleteQuery then
  begin
    { Set POP3 counter  }
    Inc(FPOPCount);
    try
      { Start POP3 session }
      with TPOP3Session.Create do
      try
        { Connect to the server }
        SetTrayHintIcon(SConnecting, -1);
        if not Connect(FOptions.Host, FOptions.Port, FOptions.TimeOut) then
        begin
          SetTrayHintIcon(SConnectError, -2);
          Exit;
        end;
        { Login }
        SetTrayHintIcon(SAuthorisation, -1);
        if not Login(FOptions.UserName, FOptions.Password) then
        begin
          SetTrayHintIcon(SAuthoriseError, -2);
          Exit;
        end;
        { Show "Deleting..." hint  }
        SetTrayHintIcon(SDeletingMessage, -1);
        try
          I := High(MsgNums);
          { Process all messages }
          while I >= Low(MsgNums) do
          try
            { Delete message }
            if not DeleteMessage(MsgNums[I]) then
            begin
              SetTrayHintIcon(SDeleteError, -2);
              Break;
            end;
            { Remove message from mail list }
            Index := FMailBox.IndexOfMsg(MsgNums[I]);
            if Index <> -1 then FMailBox.Delete(Index);
            { Next message }
            Dec(I);
          finally
            UpdateListView;
          end;
          { Check all items complete }
          if I < Low(MsgNums) then
          begin
            { Success }
            Result := True;
            SetTrayHintIcon('', FMailBox.Count);
          end;
        finally
          FMailBox.UpdateMsgNums; { ??? }
        end;
      finally
        Quit;
        Free;
      end;
      { Check for error }
      if (not Result) and FOptions.MessageBox then
      begin
        Text := FTrayIcon.Hint + '.';
        AppMessageBox(PChar(Text), PChar(Caption), MB_ICONWARNING);
      end;
    finally
      Dec(FPOPCount);
    end;
  end;
end;

procedure TCheckerForm.LaunchReader(const Reader: string);
begin
  ShellExecute(Handle, nil, PChar(Reader), nil, nil, SW_SHOWNORMAL);
end;

function TCheckerForm.LoadMessage(MsgNum: Integer): Boolean;
var
  Index: Integer;
  MsgText: string;
begin
  Result := False;
  { Get message index }
  Index := FMailBox.IndexOfMsg(MsgNum);
  { Check POP3 active }
  if (FPOPCount = 0) and (Index <> -1) then
  begin
    { Set POP3 counter  }
    Inc(FPOPCount);
    try
      { Start POP3 session }
      with TPOP3Session.Create do
      try
        { Connect to the server }
        SetTrayHintIcon(SConnecting, -1);
        if not Connect(FOptions.Host, FOptions.Port, FOptions.TimeOut) then
        begin
          SetTrayHintIcon(SConnectError, -2);
          Exit;
        end;
        { Login }
        SetTrayHintIcon(SAuthorisation, -1);
        if not Login(FOptions.UserName, FOptions.Password) then
        begin
          SetTrayHintIcon(SAuthoriseError, -2);
          Exit;
        end;
        { Receive message source }
        if not RetrieveMessage(MsgNum, MsgText) then
        begin
          SetTrayHintIcon(SLoadingError, -2);
          Exit;
        end;
        { Store message source }
        FMailBox[Index].Text := MsgText;
        FMailBox[Index].FullSource := True;
        { Success }
        SetTrayHintIcon('', FMailBox.Count);
        Result := True;
      finally
        Quit;
        Free;
      end;
      { Show error message if needed }
      if (not Result) and FOptions.MessageBox then
      begin
        MsgText := FTrayIcon.Hint + '.';
        AppMessageBox(MsgText, Caption, MB_ICONWARNING);
      end;
    finally
      Dec(FPOPCount);
    end;
  end;
end;

function TCheckerForm.OpenMessage(MsgNum: Integer): Boolean;
var
  Index: Integer;
begin
  Result := False;
  { Get message index }
  Index := FMailBox.IndexOfMsg(MsgNum);
  { Check message }
  if Index = -1 then
  begin
    if MsgNum <> -1 then SetTrayHintIcon(SLoadingError, -2);
    Exit;
  end;
  { Load message source }
  if FMailBox[Index].FullSource or LoadMessage(MsgNum) then
  begin
    { Show message }
    ShowMessageSource(FMailBox[Index].Text);
    Result := True;
  end;
end;

function TCheckerForm.PrintMessage(MsgNum: Integer): Boolean;
var
  I, Index: Integer;
  Strings: TStringList;
  PrintFile: TextFile;
begin
  Result := False;
  { Get message index }
  Index := FMailBox.IndexOfMsg(MsgNum);
  { Check message }
  if Index = -1 then
  begin
    if MsgNum <> -1 then SetTrayHintIcon(SLoadingError, -2);
    Exit;
  end;
  { Select printer }
  if PrintDialog.Execute then
    { Load message source }
    if FMailBox[Index].FullSource or LoadMessage(MsgNum) then
    begin
      SetTrayHint(SPrintingMessage);
      Screen.Cursor := crHourGlass;
      try
        { Create message buffer }
        Strings := TStringList.Create;
        try
          { Split message lines }
          Strings.Text := ChangeCharSet(FMailBox[Index].Text, FCharSet, CS_WIN);
          { Open printer }
          AssignPrn(PrintFile);
          Rewrite(PrintFile);
          { Set printer font }
          Printer.Canvas.Font.Name := 'Courier New';
          Printer.Canvas.Font.Size := 10;
          Printer.Canvas.Font.Color := clBlack;
          Printer.Canvas.Font.Style := [];
          { Title }
          Printer.Title := ChangeCharset(FMailBox[Index].Subject, FCharSet, CS_WIN);
          { Writes message to the printer }
          for I := 0 to Strings.Count - 1 do Writeln(PrintFile, Strings[I]);
          { Close printer }
          CloseFile(PrintFile);
        finally
          Strings.Free;
        end;
      finally
        Screen.Cursor := crDefault;
        SetTrayHint('');
      end;
      { Success }
      Result := True;
    end;
end;

function TCheckerForm.SaveMessage(MsgNum: Integer): Boolean;
const
  IllegalFileChars: set of Char = ['\', '/', ':', '*', '?', '"', '<', '>', '|'];
var
  I, Index: Integer;
  S, Text: string;
begin
  Result := False;
  { Get message index }
  Index := FMailBox.IndexOfMsg(MsgNum);
  { Check message }
  if Index = -1 then
  begin
    if MsgNum <> -1 then SetTrayHintIcon(SLoadingError, -2);
    Exit;
  end;
  with SaveDialog do
  begin
    { Prepare file name }
    S := ChangeCharset(FMailBox[Index].Subject, FCharSet, CS_WIN) + '.txt';
    for I := 1 to Length(S) do
      if S[I] in IllegalFileChars then S[I] := '_';
    FileName := S;
    { Select file name }
    if Execute then
      { Load message source }
      if FMailBox[Index].FullSource or LoadMessage(MsgNum) then
      begin
        SetTrayHint(SPrintingMessage);
        Screen.Cursor := crHourGlass;
        try
          { Conver mesage }
          Text := ChangeCharSet(FMailBox[Index].Text, FCharSet, CS_WIN);
          { Save message source }
          with TFileStream.Create(FileName, fmCreate) do
          try
            Write(Pointer(Text)^, Length(Text));
          finally
            Free;
          end;
        finally
          Screen.Cursor := crDefault;
          SetTrayHint('');
        end;
        { Success }
        Result := True;
      end;
  end;
end;

procedure TCheckerForm.FormCreate(Sender: TObject);
begin
  { Check previous instance }
  CheckPrevInstance;
  { Init internal params }
  FMailBox := TMailBox.Create;
  FOptions := TOptions.Create;
  { Init sort direction }
  if FSortDirect = 0 then FSortDirect := -1;
  { Hook application events }
  Application.OnHint := AppHint;
  Application.OnException := AppException;
  Application.HookMainWindow(AppHook);
  { Create and init tray icon }
  FTrayIcon := TTrayIcon.Create(Self);
  FTrayIcon.Hint := Format(SMessages, [0]);
  FTrayIcon.PopupMenu := TrayMenu;
  FTrayIcon.OnDblClick := TrayCheckerItemClick;
  FTrayIcon.OnPopup := TrayIconPopup; 
  FTrayIcon.Icon.Handle := LoadImage(HInstance, 'MBOX0', IMAGE_ICON, 0, 0, LR_VGACOLOR);
  FTrayIcon.Visible := True;
  { Load window placement }
  LoadWindowPlacement;
  { Update timer params }
  UpdateTimer;
  { Update startup settings }
  with FOptions do
  begin
    { Hide main form }
    Application.ShowMainForm := Visible;
    { Check options }
    if Length(Host) = 0 then
    begin
      Show;
      if ChangeOptions(FOptions) then UpdateTimer;
    end;
    { Check new mail }
    if CheckOnStartup then
    begin
      if Visible then Show;
      CheckNewMail(False);
    end;
  end;
end;

procedure TCheckerForm.FormDestroy(Sender: TObject);
begin
  Application.UnHookMainWindow(AppHook);
  CloseHandle(FAppMutex);
  FOptions.Free;
  FMailBox.Free;
end;

procedure TCheckerForm.FormHide(Sender: TObject);
begin
  { Update options }
  FOptions.Visible := False;
end;

procedure TCheckerForm.FormShow(Sender: TObject);
begin
  { Update options }
  FOptions.Visible := True;
end;

procedure TCheckerForm.FileMenuClick(Sender: TObject);
begin
  FileOpenItem.Enabled := (FPOPCount = 0) and (MessageNum <> -1);
  FilePrintItem.Enabled := (FPOPCount = 0) and (MessageNum <> -1);
  FileSaveItem.Enabled := (FPOPCount = 0) and (MessageNum <> -1);
  FileDeleteItem.Enabled := (FPOPCount = 0) and (MailView.SelCount > 0);
  FilePropertiesItem.Enabled := MessageNum <> -1;
end;

procedure TCheckerForm.FileOpenItemClick(Sender: TObject);
begin
  OpenMessage(MessageNum);
end;

procedure TCheckerForm.FileSaveItemClick(Sender: TObject);
begin
  SaveMessage(MessageNum);
end;

type
  PIntList = ^TIntList;
  TIntList = array[0..MaxInt div SizeOf(Integer) - 1] of Integer;

procedure TCheckerForm.FileDeleteItemClick(Sender: TObject);
var
  MsgNums: PIntList;
  I: Integer;
  Item: TListItem;
begin
  with MailView do
  begin
    GetMem(MsgNums, SelCount * SizeOf(Integer));
    try
      { Get message list }
      I := 0;
      Item := Selected;
      while Item <> nil do
      begin
        MsgNums[I] := TMailMessage(Item.Data).MsgNum;
        Inc(I);
        Item := GetNextItem(Item, sdAll, [isSelected]);
      end;
      { Delete messages }
      DeleteMessage(Slice(MsgNums^, I));
    finally
      FreeMem(MsgNums);
    end;
  end;
end;

procedure TCheckerForm.FilePrintItemClick(Sender: TObject);
begin
  PrintMessage(MessageNum);
end;

procedure TCheckerForm.FilePropertiesItemClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := FMailBox.IndexOfMsg(MessageNum);
  if Index <> -1 then ShowMessageProperties(FMailBox[Index].Text);
end;

procedure TCheckerForm.FileExitItemClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TCheckerForm.ViewMenuClick(Sender: TObject);
begin
  ViewStatusBarItem.Checked := StatusBar.Visible;
end;

procedure TCheckerForm.ViewStatusBarItemClick(Sender: TObject);
begin
  StatusBar.Visible := not TMenuItem(Sender).Checked;
end;

procedure TCheckerForm.ViewSortMenuClick(Sender: TObject);
begin
  ViewSortFromItem.Checked := FSortColumn = 0;
  ViewSortSubjectItem.Checked := FSortColumn = 1;
  ViewSortDateItem.Checked := FSortColumn = 2;
  ViewSortSizeItem.Checked := FSortColumn = 3;
  ViewSortDirectItem.Checked := FSortDirect = 1;
end;

procedure TCheckerForm.ViewSortItemClick(Sender: TObject);
begin
  SetSortColumn(TMenuItem(Sender).Tag);
end;

procedure TCheckerForm.ViewSortDirectItemClick(Sender: TObject);
begin
  SetSortDirect(FSortDirect * (-1));
end;

procedure TCheckerForm.ViewCharSetMenuClick(Sender: TObject);
begin
  ViewDOSItem.Checked := FCharSet = CS_DOS;
  ViewWINItem.Checked := FCharSet = CS_WIN;
  ViewKOIItem.Checked := FCharSet = CS_KOI;
  ViewNoItem.Checked := FCharSet = -1;
end;

procedure TCheckerForm.ViewCharSetItemClick(Sender: TObject);
begin
  SetCharSet(TMenuItem(Sender).Tag);
end;

procedure TCheckerForm.ViewRefreshItemClick(Sender: TObject);
begin
  UpdateListView;
end;

procedure TCheckerForm.MailMenuClick(Sender: TObject);
begin
  MailCheckItem.Enabled := FPOPCount = 0;
  MailReaderItem.Enabled := Length(FOptions.MailReader) > 0;
  MailOptionsItem.Enabled := FPOPCount = 0;
end;

procedure TCheckerForm.MailCheckItemClick(Sender: TObject);
begin
  CheckNewMail(True);
end;

procedure TCheckerForm.MailReaderItemClick(Sender: TObject);
begin
  LaunchReader(FOptions.MailReader);
end;

procedure TCheckerForm.MailOptionsItemClick(Sender: TObject);
begin
  if StartDialog then
  try
    if ChangeOptions(FOptions) then
    begin
      UpdateTimer;
      if FOptions.Checking then CheckNewMail(False);
    end;
  finally
    StopDialog;
  end;
end;

procedure TCheckerForm.HelpTopicsItemClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TCheckerForm.HelpAboutItemClick(Sender: TObject);
begin
  if StartDialog then
  try
    ShowAboutDialog;
  finally
    StopDialog;
  end;
end;

procedure TCheckerForm.PopupMenuPopup(Sender: TObject);
begin
  PopupOpenItem.Enabled := (FPOPCount = 0) and (MessageNum <> -1);
  PopupPrintItem.Enabled := (FPOPCount = 0) and (MessageNum <> -1);
  PopupSaveItem.Enabled := (FPOPCount = 0) and (MessageNum <> -1);
  PopupDeleteItem.Enabled := (FPOPCount = 0) and (MailView.SelCount > 0);
  PopupPropertiesItem.Enabled := MessageNum <> -1;
end;

procedure TCheckerForm.TrayMenuPopup(Sender: TObject);
begin
  TrayCheckItem.Enabled := FPOPCount = 0;
  TrayOptionsItem.Enabled := FPOPCount = 0;
end;

procedure TCheckerForm.TrayCheckerItemClick(Sender: TObject);
begin
  { Check dialog }
  if not FDialogMsg then Show;
  { Bring application to front }
  Application.Restore;
  Application.BringToFront;
end;

procedure TCheckerForm.TrayIconPopup(Sender: TObject; var AllowPopup: Boolean);
begin
  AllowPopup := not FDialogMsg;
  { Brind dialog form to top }
  if not AllowPopup then
  begin
    Application.Restore;
    Application.BringToFront;
  end;
end;

procedure TCheckerForm.TimerTimer(Sender: TObject);
begin
  CheckNewMail(False);
end;

procedure TCheckerForm.MailViewColumnClick(Sender: TObject; Column: TListColumn);
begin
  { Change sort column }
  if FSortColumn <> Column.Index then
  begin
    SetSortColumn(Column.Index);
    Exit;
  end;
  { Change sort direction }
  SetSortDirect(FSortDirect * (-1));
end;

procedure TCheckerForm.MailViewDblClick(Sender: TObject);
begin
  OpenMessage(MessageNum);
end;

procedure TCheckerForm.MailViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Shift = [] then
    case Key of
      VK_RETURN:
        begin
          FileMenu.Click;
          FileOpenItem.Click;
          Key := 0;
        end;
      VK_DELETE:
        begin
          FileMenu.Click;
          FileDeleteItem.Click;
          Key := 0;
        end;
      VK_F5:
        begin
          MailMenu.Click;
          MailCheckItem.Click;
          Key := 0;
        end;
    end;
  if Shift = [ssCtrl] then
    case Key of
      VK_RETURN:
        begin
          FileMenu.Click;
          FilePropertiesItem.Click;
          Key := 0;
        end;
    end;
end;

end.

