{
  POP3 Mail Checker

  Message information form

  Roman M. Mochalov
  E-mail: roman@sar.nnov.ru
}

unit MC_Properties;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TPropertiesForm = class(TForm)
    PropertiesPage: TPageControl;
    PropertiesSheet: TTabSheet;
    HeadersLabel: TLabel;
    HeadersMemo: TMemo;
    OKButton: TButton;
    CancelButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure HeadersMemoKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowMessageProperties(const Message: string);

implementation

uses MC_Form, MC_Mail;

{$R *.DFM}

procedure ShowMessageProperties(const Message: string);
begin
  with TPropertiesForm.Create(nil) do
  try
    { Update controls }
    Caption := ExtractMessageHeader(Message, SSubject);
    HeadersMemo.Text := ExtractMessageHeaders(Message);
    { Show form }
    ShowModal;
  finally
    Free;
  end;
end;

{ TPropertiesForm }

procedure TPropertiesForm.FormCreate(Sender: TObject);
var
  R: TRect;
  X, Y: Integer;
begin
  SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
  X := CheckerForm.Left + 20;
  if X < R.Left then X := R.Left;
  if X + Width > R.Right then X := R.Right - Width;
  Left := X;
  Y := CheckerForm.Top + 20;
  if Y < R.Top + 5 then Y := R.Top + 5;
  if Y + Height > R.Bottom - 5 then Y := R.Bottom - 5 - Height;
  Top := Y;
end;

procedure TPropertiesForm.HeadersMemoKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
  begin
    Close;
    Key := 0;
  end;
end;

end.
